package com.gic.haoban.manage.service.dao.mapper;

import com.gic.haoban.manage.service.entity.MemberUnionidRelated;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

public interface MemberUnionidRelatedMapper {

    int insert(MemberUnionidRelated record);

    MemberUnionidRelated selectByPrimaryKey(String memberUnionidRelatedId);

    int updateByPrimaryKeySelective(MemberUnionidRelated record);

    int cleanByCid(@Param("cid") String cid);

    MemberUnionidRelated getByUnionId(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("staffId") String staffId, @Param("unionid") String unionid);

    void deleteByUnionidAndUserId(@Param("externalUserid") String externalUserid, @Param("staffId") String staffId);

    void delMemberUnionidRelatedBatch(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("externalUserids") List<String> externalUserid, @Param("staffId") String staffId);

    List<MemberUnionidRelated> listByEnterpriseIdAndDate(@Param("enterpriseId") String enterpriseId, @Param("date") Date date);

    void cleanStaffRelated(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("staffIds") List<String> staffIds);

    /**
     * 根据应用内的外部联系人获取信息
     *
     * @param wxUserId
     * @param wxEnterpriseId
     * @param selfExternalUserId
     * @return
     */
    MemberUnionidRelated getBySelfExternalUserId(@Param("staffId") String staffId, @Param("wxEnterpriseId") String wxEnterpriseId, @Param("selfExternalUserId") String selfExternalUserId);

    List<MemberUnionidRelated> listBySelfExternalUserId(@Param("staffId") String staffId, @Param("wxEnterpriseId") String wxEnterpriseId, @Param("selfExternalUserId") String selfExternalUserId);

    /**
     * 更新外部用户id的老外部用户id
     *
     * @param new_external_userid 新的外部标识
     * @param external_userid     外部用户标识
     * @param wxEnterpriseId      wx企业标识
     * @return int
     * @author mozhu
     * @date 2021-12-29 16:30:43
     */
    int updateExternalUserIdByOldExternalUserId(@Param("newExternalUserId") String new_external_userid,
                                                @Param("oldExternalUserId") String external_userid,
                                                @Param("wxEnterpriseId") String wxEnterpriseId);

    /**
     * wx企业id查询数据
     *
     * @param wxEnterpriseId wx企业标识
     * @return {@link List }<{@link MemberUnionidRelated }>
     * @author mozhu
     * @date 2022-06-30 17:35:50
     */
    List<MemberUnionidRelated> listByWxEnterpriseId(@Param("wxEnterpriseId") String wxEnterpriseId);

}