package com.gic.haoban.manage.service.service.out.impl;

import java.util.Map;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.commons.util.GICMQClientUtil;
import com.gic.haoban.manage.api.dto.CommonMQDTO;
import com.gic.haoban.manage.api.service.HaobanCommonMQApiService;
import com.gic.mq.sdk.GicMQClient;
import com.gic.quartz.api.dto.QuartzTaskDTO;
import com.gic.quartz.api.service.QuartzService;

@Service("haobanCommonMQApiService")
public class HaobanCommonMQApiServiceImpl implements HaobanCommonMQApiService {

    private final Logger log = LogManager.getLogger(HaobanCommonMQApiService.class);

    private static GicMQClient mqClient = GICMQClientUtil.getClientInstance();
    
    @Autowired
    private QuartzService quartzService ;

    @Override
    public void putCommonMessage(CommonMQDTO dto) {
        String message = JSONObject.toJSONString(dto);
        log.info("接收信息={}",message);
        try {
            mqClient.sendCommonMessage("marketingCommonRouter", message,
                    "com.gic.haoban.manage.api.service.HaobanCommonMQApiService", "commonHandler");
        } catch (Exception e) {
            log.error("发送MQ异常");
            e.printStackTrace();
        }
    }

    @Override
    public void commonHandler(String message) {
        CommonMQDTO dto = JSON.parseObject(message, CommonMQDTO.class);
        // 好办停用,删除定时
        if(dto.getType()==1) {
            Map<String,String> map = (Map<String, String>) dto.getParams() ;
            String enterpriseId = map.get("enterpriseId") ;
            this.deleteQuartz(enterpriseId);
        }
    }
    
    private void deleteQuartz(String enterpriseId) {
        log.info("删除好办定时eid={}",enterpriseId);
        QuartzTaskDTO task = new QuartzTaskDTO();
        task.setTaskService("com.gic.haoban.app.daily.api.service.DailyReportJobApiService");
        task.setTaskMethod("callBack");
        task.setReferId(enterpriseId);
        this.quartzService.delQuartzTask(task);
    }
}
